using JiShe.CollectBus.Protocol.Contracts.Protocol.Dto;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol.T37612012.Appendix;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;

namespace JiShe.CollectBus.Protocol.T37612012.AnalysisData.AFN_0CH
{
    /// <summary>
    /// 5.12.2.4.88 F132：当前反向无功（组合无功 2）电能示值（总、费率 1～M）
    /// </summary>
    public class AFN12_F132_Analysis : IAnalysisStrategy<TB3761>
    {

        private readonly ILogger<AFN12_F132_Analysis> _logger;
        private readonly AnalysisStrategyContext _analysisStrategyContext;

        public AFN12_F132_Analysis(ILogger<AFN12_F132_Analysis> logger, AnalysisStrategyContext analysisStrategyContext)
        {
            _logger = logger;
            _analysisStrategyContext = analysisStrategyContext;
        }


        public async Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.UnitData?.HexMessageList);
                List<string> datas = await AnalysisDataUnitAsync(input.UnitData.HexMessageList);
                List<AFN12_F132_AnalysisDto> list = GenerateFinalResult(2, datas, "反向无功电能示值", (int)input.AFN_FC.AFN!, (int)input.DT.Fn!);
                UnitDataAnalysis<List<AFN12_F132_AnalysisDto>> unitDataAnalysis = new UnitDataAnalysis<List<AFN12_F132_AnalysisDto>>
                {
                    Code = input.A.Code!,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn ,
                    Pn = input.DA.Pn,
                    Data = list,
                    HexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    ReceivedTime = input.ReceivedTime
                };
                result?.Invoke(unitDataAnalysis);
                return await Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"0C_132解析失败:{input.A.Code}-{input.DT.Fn}-{input.BaseHexMessage.HexMessageString},{ex.Message}");

            }
            return await Task.FromResult(false);

        }
        private async Task<List<string>> AnalysisDataUnitAsync(List<string> hexMessageList)
        {
            List<string> values = new List<string>();
            values.Add(hexMessageList.GetReadTime(4, 5));
            int ratingCount = hexMessageList.GetRatingCount(9, 1);
            values.Add(ratingCount.ToString());
            for (int i = 0; i < ratingCount + 1; i++)
            {
                var arr = hexMessageList.GetRange(10 + (i * 4), 4);
                var errorCode = arr.CheckErrorCode();
                if (errorCode != null)
                    values.Add(errorCode.Item1);
                else
                {
                    await _analysisStrategyContext.ExecuteAsync<List<string>>(nameof(Appendix_A11), arr, (value) =>
                    {
                        values.Add(value.ToString());
                    }); //从第10个开始，每加5个字节为下一个值的开始
                }
            }
            return values;
        }
        public List<AFN12_F132_AnalysisDto> GenerateFinalResult(int index, List<string> data, string remark = "",int afn=0,int fn=0)
        {
            List<AFN12_F132_AnalysisDto> list = new List<AFN12_F132_AnalysisDto>();
            for (int i = index; i < data.Count; i++)
            {
                AFN12_F132_AnalysisDto meter = new AFN12_F132_AnalysisDto();
                decimal value = 0;
                var errorCode = data[i].CheckErrorCode();
                if (errorCode != null)
                    meter.ValidData = false;
                else
                    decimal.TryParse(data[i], out value);
                meter.DataValue = value;
                meter.DataType = $"{afn.ToString().PadLeft(2, '0')}_{fn}_{i - index}";
                meter.ReadTime = Convert.ToDateTime($"{data[0].Substring(0, 4)}-{data[0].Substring(4, 2)}-{data[0].Substring(6, 2)} {data[0].Substring(8, 2)}:{data[0].Substring(10, 2)}:00");
                list.Add(meter);
            }
            return list;
        }

       
    }
}
